# First check, if the PowerShell "AD Modul" is available.
# Zuerst prfen, ob das PowerShell AD Modul installiert ist.
# --------------------------------------------------------

if(Get-Command Get-ADUser -ErrorAction SilentlyContinue)
{
    # OK, the Powershell "AD Modul" is available.
}
else
{
    # First, we need to install the Powershell "AD Modul"!

    Import-Module ServerManager
    Add-WindowsFeature -Name "RSAT-AD-PowerShell" -IncludeAllSubFeature

}


# The following Powershell command exports all active users to a CSV file.
# Das folgende Powershell Kommando exportiert alle aktiven Benutzer in eine CSV-Datei.
# --------------------------------------------------------

Get-ADUser -Properties * -LDAPFilter "(&(objectCategory=person)(objectClass=user)(!userAccountControl:1.2.840.113556.1.4.803:=2))" | 
  sort-object Name | 
  Select-Object `
  @{Label = "ObjectGUID";         Expression = {$_.objectGUID}},
  @{Label = "ClientName";         Expression = {$_.samAccountName}},
  @{Label = "ClientNameNew";      Expression = {""}},
  @{Label = "LastName";           Expression = {$_.surname}},
  @{Label = "FirstName";          Expression = {$_.givenName}},
  @{Label = "PhoneNumber";        Expression = {$_.telephoneNumber}},
  @{Label = "EMail";              Expression = {$_.mail}},
  @{Label = "Department";         Expression = {$_.department}},
  @{Label = "TapiDevice";         Expression = {""}},
  @{Label = "UserParam1";         Expression = {""}} |
  export-csv -NoTypeInformation -delimiter ";" -encoding utf8 -Path ad_users.csv 



# Hint: Format of the "Select-Object" command:
# --------------------------------------------------------
# Select-Object objectGUID,samAccountName,name,givenName,surname,title,company,department,telephoneNumber,ipPhone,homePhone,mobile,mail,whenChanged | 

# Hint: more available Params:
# --------------------------------------------------------
# UserPrincipalName,cn;description;distinguishedName;whenCreated;groupType;sn;displayName;
# @{Label = "Company";            Expression = {$_.company}},
# @{Label = "IPPhone";            Expression = {$_.ipPhone}},
# @{Label = "Mobile";             Expression = {$_.mobile}},
# @{Label = "WhenChanged";        Expression = {$_.whenChanged}}  |
  
